10     DIM Pri$[9],Sec$[9],Inp_char$[9]
20     REAL Freq,Lvl,Pri_res,Sec_res
30     INTEGER Cbl,Result,Meas_stat
40     CLEAR SCREEN
50     !
60     ASSIGN @Agt4288a TO 717
70     !
80     Pri$="CP"
90     Sec$="Q"
100    Freq=1.E+6
110    Lvl=.5
120    Cbl=0
130    !
140    PRINT "Connect Test Fixture, then Push [Enter] key."
150    INPUT "",Inp_char$
160    !
170    OUTPUT @Agt4288a;":SYST:PRES"
180    !
190    OUTPUT @Agt4288a;":CALC1:FORM ";Pri$
200    OUTPUT @Agt4288a;":CALC2:FORM ";Sec$
210    OUTPUT @Agt4288a;":SOUR:FREQ ";Freq
220    OUTPUT @Agt4288a;":SOUR:VOLT ";Lvl
230    OUTPUT @Agt4288a;":CAL:CABL ";Cbl
240    !
250    Result=FNCompen(@Agt4288a,"Open",.00002)
260    IF Result<>0 THEN Prog_end
270    Result=FNCompen(@Agt4288a,"Short",20)
280    IF Result<>0 THEN Prog_end
290    !
300    OUTPUT @Agt4288a;":TRIG:SOUR BUS"
310    OUTPUT @Agt4288a;":INIT:CONT ON"
320    !
330 Meas_start: !
340    PRINT "Set DUT, then Push [Enter] key."
350    INPUT "",Inp_char$
360    OUTPUT @Agt4288a;"*TRG"
370    ENTER @Agt4288a;Meas_stat,Pri_res,Sec_res
380    !
390    ! Display results
400    !
410    PRINT "[MEASUREMENT RESULT]"
420    IF Meas_stat=1 THEN 
430      PRINT USING "X,3A,6A";Pri$,": OVLD"
440      PRINT USING "X,3A,6A";Sec$,": OVLD"
450    ELSE
460      PRINT USING "X,3A,A,X,SD.5DE";Pri$,":",Pri_res
470      PRINT USING "X,3A,A,X,SD.5DE";Sec$,":",Sec_res
480    END IF
490    !
500    INPUT "Once more? [Y]es/[N]o",Inp_char$
510    IF UPC$(Inp_char$)="Y" OR UPC$(Inp_char$)="YES" THEN Meas_start
520    !
530 Prog_end:  END
540    !=============================================
550    ! Compensation Data Measurement Function
560    !=============================================
570  DEF FNCompen(@Agt4288a,Standard$,Limit)
580    DIM Inp_char$[9],Buff$[9],Std$[9],Err$[50]
590    REAL Curr_freq,Freq(1:2),Para1,Para2,Zm,Ym,Gm,Bm
600    REAL Cpref,Dref,Zref,Gref,Bref
610    INTEGER Err_flag
620    OUTPUT @Agt4288a;":SOUR:FREQ?"
630    ENTER @Agt4288a;Curr_freq
640    Freq(1)=1.E+3
650    Freq(2)=1.E+6
660    Load_para$="CPD"
670    OUTPUT @Agt4288a;":STAT:OPER:ENAB 128"
680    OUTPUT @Agt4288a;"*SRE 128"
690    SELECT Standard$
700      CASE "Open"
710        Std$="STAN1"
720      CASE "Short"
730        Std$="STAN2"
740      CASE "Load"
750        Std$="STAN3"
760        CALL Inp_data("Load(Cp) Value @1kHz",Load1(1))
770        CALL Inp_data("Load(D)  Value @1kHz",Load2(1))
780        CALL Inp_data("Load(Cp) Value @1MHz",Load1(2))
790        CALL Inp_data("Load(D)  Value @1MHz",Load2(2))
800        OUTPUT @Agt4288a;":CORR:CKIT:STAN3:FORM "&Load_para$
810        FOR I=1 TO 2
820          OUTPUT @Agt4288a;":SOUR:FREQ ";Freq(I)
830          OUTPUT @Agt4288a;":CORR:CKIT:STAN3 ";Load1(I);",";Load2(I)
840        NEXT I
850    END SELECT
860 Compen_meas:  !
870    PRINT "Set "&Standard$&"-Connection."
880    INPUT "OK? [Y/N]",Inp_char$
890    IF UPC$(Inp_char$)="Y" THEN 
900      FOR I=1 TO 2
910        PRINT "Frequency:";Freq(I)
920        OUTPUT @Agt4288a;":SOUR:FREQ ";Freq(I)
930        OUTPUT @Agt4288a;"*CLS"
940        OUTPUT @Agt4288a;"*OPC?"
950        ENTER @Agt4288a;Buff$
960        ! Measurement
970        ON INTR 7 GOTO Meas_end
980        ENABLE INTR 7;2
990        OUTPUT @Agt4288a;":CORR:COLL "&Std$
1000 Meas_wait: GOTO Meas_wait
1010 Meas_end: OFF INTR 7
1020       ! Error Check
1030       OUTPUT @Agt4288a;":SYST:ERR?"
1040       ENTER @Agt4288a;Err_no,Err$
1050       IF Err_no<>0 THEN 
1060         PRINT "Error: "&Err$
1070         GOTO Compen_meas
1080       END IF
1090       ! Data Check
1100       OUTPUT @Agt4288a;":CORR:DATA? "&Std$
1110       ENTER @Agt4288a;Para1,Para2
1120       Err_flag=0
1130       SELECT Standard$
1140         CASE "Open"
1150           Ym=SQRT(Para1*Para1+Para2*Para2)
1160           PRINT "G =";Para1,"B =";Para2,"|Y| =";Ym
1170           IF Ym>=Limit THEN Err_flag=1
1180         CASE "Short"
1190           Zm=SQRT(Para1*Para1+Para2*Para2)
1200           PRINT "R =";Para1,"X =";Para2,"|Z| =";Zm
1210           IF Zm>=Limit THEN Err_flag=1
1220         CASE "Load"
1230           OUTPUT @Agt4288a;":CORR:CKIT:STAN3?"
1240           ENTER @Agt4288a;Cpref,Dref
1250           Bref=2*PI*Freq(I)*Cpref
1260           Gref=Bref*Dref
1270           Zref=1/SQRT(Gref*Gref+Bref*Bref)
1280           Bm=2*PI*Freq(I)*Para1
1290           Gm=Bm*Para2
1300           Zm=1/SQRT(Gm*Gm+Bm*Bm)
1310           PRINT "Cpref=";Cpref,"Dref=";Dref,"|Zref| =";Zref
1320           PRINT "Cp   =";Para1,"D   =";Para2,"|Z|    =";Zm
1330           IF ABS((Zm-Zref)/Zref)>=Limit THEN Err_flag=1
1340       END SELECT
1350       IF Err_flag<>0 THEN 
1360         PRINT "Out of limit!!"
1370         GOTO Compen_meas
1380       END IF
1390     NEXT I
1400     PRINT Standard$&" Data Measurement Complete"
1410     OUTPUT @Agt4288a;":SOUR:FREQ ";Curr_freq
1420     RETURN 0
1430   ELSE
1440     PRINT "Program Interruption"
1450     OUTPUT @Agt4288a;":SOUR:FREQ ";Curr_freq
1460     RETURN -1
1470   END IF
1480 FNEND
1490   !=============================================
1500   ! Data Input Function
1510   !=============================================
1520 SUB Inp_data(Mes$,Inp_val)
1530   DIM Inp_char$[30]
1540   ON ERROR GOTO Inp_start
1550 Inp_start:!
1560   PRINT "Input "&Mes$
1570   INPUT "Value?",Inp_char$
1580   Inp_val=VAL(UPC$(Inp_char$))
1590   PRINT "Input Value: ";Inp_val
1600   INPUT "OK? [Y/N]",Inp_char$
1610   IF UPC$(Inp_char$)<>"Y" THEN Inp_start
1620   OFF ERROR 
1630 SUBEND
5000   !*************************************************
5010   !* DESCRIPTION:  Agilent 4288A Sample Program
5020   !*
5030   !* AUTHOR:       Agilent Technologies Japan, Ltd.
5040   !* CREATED:      12/1/2000
5050   !* PROGRAM NAME: meas_fxt.bas
5060   !* REVISION:     A.01.00
5070   !*
5080   !*     Copyright (c) Agilent Technologies,
5090   !*              All rights reserved.
5100   !*
5110   !*
5120   !*  Customer shall have the personal, non-
5130   !* transferable rights to use, copy or modify
5140   !* this SAMPLE PROGRAM for Customer's internal
5150   !* operations. Customer shall use the SAMPLE
5160   !* PROGRAM solely and exclusively for its own
5170   !* purpose and shall not license, lease, market
5180   !* or distribute the SAMPLE PROGRAM or
5190   !* modification or any part thereof.
5200   !*
5210   !*  Agilent Technologies shall not be liable for
5220   !* the quality, performance or behavior of the
5230   !* SAMPLE PROGRAM. Agilent Technologies especially
5240   !* disclaims that the operation of the SAMPLE
5250   !* PROGRAM shall be uninterrupted or error free.
5260   !* This SAMPLE PROGRAM is provided AS IS.
5270   !*
5280   !*  AGILENT TECHNOLOGIES DISCLAIMS THE IMPLIED
5290   !* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
5300   !* A PARTICULAR PURPOSE.
5310   !*
5320   !*  Agilent Technologies shall not be liable for
5330   !* any infringement of any patent, trademark,
5340   !* copyright or other proprietary rights by the
5350   !* SAMPLE PROGRAM or its use. Agilent Technologies
5360   !* does not warrant that the SAMPLE PROGRAM is
5370   !* free from infringements or such rights of third
5380   !* parties. However, Agilent Technologies will not
5390   !* knowingly infringe or deliver a software that
5400   !* infringes the patent, trademark, copyright or
5410   !* other proprietary right of a third party.
5420   !*
5430   !*************************************************
